# Class ServiceBuilder

Creates remote.DriverService instances that manage a ChromeDriver server.

#### Hierarchy

- Builder
  - ServiceBuilder

#####
Index

### Constructors

constructor

### Methods

addArguments
build
enableVerboseLogging
loggingTo
setAdbPort
setEnvironment
setHostname
setLoopback
setNumHttpThreads
setPath
setPort
setStdio

## Constructors

### constructor

- new ServiceBuilder(opt_exe?): ServiceBuilder

- #### Parameters

  - ##### `Optional` opt_exe: string

    Path to the server executable to use. If omitted, the builder will attempt to locate the chromedriver on the current PATH.

  #### Returns ServiceBuilder

  #### Throws

  If provided executable does not exist, or the chromedriver cannot be found on the PATH.

  Overrides Builder.constructor

## Methods

### addArguments

- addArguments(...var_args): ServiceBuilder

- Define additional command line arguments to use when starting the server.

  #### Parameters

  - ##### `Rest` ...var_args: string[]

    The arguments to include.

  #### Returns ServiceBuilder

  A self reference.

  Inherited from Builder.addArguments

### build

- build(): DriverService

- Creates a new DriverService using this instance's current configuration.

  #### Returns DriverService

  A new driver service.

  Inherited from Builder.build

### enableVerboseLogging

- enableVerboseLogging(): ServiceBuilder

- Enables verbose logging.

  #### Returns ServiceBuilder

  A self reference.

### loggingTo

- loggingTo(path): ServiceBuilder

- Sets the path of the log file the driver should log to. If a log file is not specified, the driver will log to stderr.

  #### Parameters

  - ##### path: string

    Path of the log file to use.

  #### Returns ServiceBuilder

  A self reference.

### setAdbPort

- setAdbPort(port): ServiceBuilder

- Sets which port adb is listening to. The ChromeDriver will connect to adb if an Android session is requested, but adb must be started beforehand.

  #### Parameters

  - ##### port: number

    Which port adb is running on.

  #### Returns ServiceBuilder

  A self reference.

### setEnvironment

- setEnvironment(env): ServiceBuilder

- Defines the environment to start the server under. This setting will be inherited by every browser session started by the server. By default, the server will inherit the enviroment of the current process.

  #### Parameters

  - ##### env: null | Map<string, string> | {
    [name: string]: string;
    }

    The desired environment to use, or `null` if the server should inherit the current environment.

  #### Returns ServiceBuilder

  A self reference.

  Inherited from Builder.setEnvironment

### setHostname

- setHostname(hostname): ServiceBuilder

- Sets the host name to access the server on. If specified, the #setLoopback() loopback setting will be ignored.

  #### Parameters

  - ##### hostname: string

  #### Returns ServiceBuilder

  A self reference.

  Inherited from Builder.setHostname

### setLoopback

- setLoopback(loopback): ServiceBuilder

- Sets whether the service should be accessed at this host's loopback address.

  #### Parameters

  - ##### loopback: boolean

  #### Returns ServiceBuilder

  A self reference.

  Inherited from Builder.setLoopback

### setNumHttpThreads

- setNumHttpThreads(n): ServiceBuilder

- Sets the number of threads the driver should use to manage HTTP requests. By default, the driver will use 4 threads.

  #### Parameters

  - ##### n: number

    The number of threads to use.

  #### Returns ServiceBuilder

  A self reference.

### setPath

- setPath(basePath): ServiceBuilder

- Sets the base path for WebDriver REST commands (e.g. "/wd/hub"). By default, the driver will accept commands relative to "/".

  #### Parameters

  - ##### basePath: null | string

    The base path to use, or `null` to use the default.

  #### Returns ServiceBuilder

  A self reference.

  Inherited from Builder.setPath

### setPort

- setPort(port): ServiceBuilder

- Sets the port to start the server on.

  #### Parameters

  - ##### port: number

    The port to use, or 0 for any free port.

  #### Returns ServiceBuilder

  A self reference.

  #### Throws

  If an invalid port is specified.

  Inherited from Builder.setPort

### setStdio

- setStdio(config): ServiceBuilder

- IO configuration for the spawned server process. For more information, refer to the documentation of `child_process.spawn`.

  #### Parameters

  - ##### config: any

    The desired IO configuration.

  #### Returns ServiceBuilder

  A self reference.

  #### See

  https://nodejs.org/dist/latest-v4.x/docs/api/child_process.html#child_process_options_stdio

  Inherited from Builder.setStdio

Generated using TypeDoc